/*******************************************************************************
 * Copyright (c) 2016 Dec. Verimag. All rights reserved.
 * @author Hang YU
 * A ray starts from a point and goes to infinity along a direction.
 * As in the raytraing method all the rays start from the same point which is 
 * stored in Raytracing class, a Ray object only contains the direction.
*******************************************************************************/

#ifndef _POINT
#define _POINT
#include "point.h"
#endif

class Ray {
public:
  Ray (const Vector& direction) {
    _direction = direction ;
    _direction.normalize() ;
  }
  
  Ray (const Point& p1, const Point& p2) {
    _direction = p1.get_coordinates() - p2.get_coordinates() ;
    _direction.normalize() ;
  } 

  Vector get_direction () const {
    return _direction ;
  }

private:
  Vector _direction ;
} ;
