/*******************************************************************************
 * Copyright (c) 2017 Jan. Verimag. All rights reserved.
 * @author Hang YU
 * This class provides some functions used library APRON.
 * An object of ApronInterface stores the constraints of a polyhedron. 
 * When we transform ap_lincons1_array_t to ap_abstract1_t, it will eliminate 
 * the redundant constraints, so we do not need to do extra work for 
 * minimization.
*******************************************************************************/

#include <ap_global1.h>
#include <pk.h>
#ifndef _POLYH
#define _POLYH
#include "polyhedron.h"
#endif

class ApronInterface {
public:
  ApronInterface (const Polyhedron& poly) ;
  ~ApronInterface () ;
  void GetAbstractVal () ;
  bool CompareAbstract (const ApronInterface& apron) ;
  int GetGeneratorNum () ;
  ap_abstract1_t get_abs () const ;
  void Print () ;
private:  
  ap_manager_t* _man ; 
  ap_environment_t* _env ;
  ap_lincons1_array_t _cons_array ;
  ap_abstract1_t _abs ;
  ap_generator1_array_t _generator ;
} ;
