#include <iostream>
#include <vector>
#include <ctime>
#include <fstream>
#include "ioInterface.h"
#include "glpkInterface.h"

int main(int argc, char* argv[]) {
  if(argc != 2) {
    std::cerr << "usage: " << argv[0] << " <filename>" << std::endl ;
    return -1 ; 
  }
  std::vector<Polyhedron> polyVec = IoInterface::LoadPolyhedra(argv[1]) ; 
  // test if polyVec[0] is included in polyVec[1]
  Polyhedron miniPoly1 = polyVec[0].GetMinimizedPoly() ;
  Polyhedron miniPoly2 = polyVec[1].GetMinimizedPoly() ;
  miniPoly1.set_central_point( GlpkInterface::GetCentralPoint(miniPoly1) ) ;
  bool res = miniPoly2.Include(miniPoly1) ;
  if (res == true) {
    std::cout << "The first polyhedron is included in the second one" << std::endl ;
  }
  else {
    std::cout << "The first polyhedron is NOT included in the second one" << std::endl ; 
  }

  return 0 ;
}
