// g++ -std=c++11 -I /opt/linalg/include -L/opt/linalg/lib -Wall -fopenmp -march=native -mtune=native demo_echelonize.cpp -o demo_echelonize -llinbox -lgivaro -lgmp

#include <linbox/linbox-config.h>
#include <linbox/matrix/dense-matrix.h>
#include <linbox/algorithms/echelon-form.h>
#include <iostream>

int main() {
  typedef Givaro::QField<Givaro::Rational> Rationals;
  Rationals QQ;
  LinBox::DenseMatrix<Rationals> A(QQ, 4, 4), B(QQ, A.rowdim(), A.coldim());
  
  A.setEntry(0, 0, Givaro::Rational(1, 3));
  A.setEntry(0, 1, 2);
  A.setEntry(0, 2, 3);
  A.setEntry(0, 3, 4);
  A.setEntry(1, 0, 5);
  A.setEntry(1, 1, 6);
  A.setEntry(1, 2, 7);
  A.setEntry(1, 3, 8);
  A.setEntry(2, 0, 9);
  A.setEntry(2, 1, 10);
  A.setEntry(2, 2, Givaro::Rational(5, 11));
  A.setEntry(2, 3, 12);
  A.setEntry(3, 0, 13);
  A.setEntry(3, 1, 14);
  A.setEntry(3, 2, 15);
  A.setEntry(3, 3, 16);

  LinBox::EchelonFormDomain<Rationals> EFD (QQ);
  EFD.columnEchelon(A);
  
  std::cout << A << std::endl;
}
