#include <stdlib.h>
#include <stdio.h>
#include "QSopt_ex.h"

int main() {
  mpq_t v1, x[3];

  QSexactStart();
  mpq_init(v1);
  mpq_init(x[0]);
  mpq_init(x[1]);
  mpq_init(x[2]);

  QSopt_ex_version();
  mpq_QSdata *lp = mpq_QScreate_prob ("problem", QS_MAX);
  {
    mpq_set_si(v1, 5, 1);
    mpq_QSnew_col(lp, v1, mpq_zeroLpNum, mpq_ILL_MAXDOUBLE, "x");
    mpq_QSnew_col(lp, v1, mpq_zeroLpNum, mpq_ILL_MAXDOUBLE, "y");
    {
      mpq_set_si(v1, 10, 1);
      mpq_QSnew_row(lp, v1, 'L', "c1");
      mpq_set_si(v1, 2, 1);
      mpq_QSchange_coef(lp, 0, 0, v1);
      mpq_set_si(v1, 1, 1);
      mpq_QSchange_coef(lp, 0, 1, v1);
    }
    {
      mpq_set_si(v1, 3, 1);
      mpq_QSnew_row(lp, v1, 'L', "c2");
      mpq_set_si(v1, 1, 1);
      mpq_QSchange_coef(lp, 1, 0, v1);
      mpq_set_si(v1, 1, 2);
      mpq_QSchange_coef(lp, 1, 1, v1);
    }
#if 0
    {
      mpq_set_si(v1, 2, 1);
      mpq_QSnew_row(lp, v1, 'L', "c3");
      mpq_set_si(v1, 1, 2);
      mpq_QSchange_coef(lp, 2, 0, v1);
      mpq_set_si(v1, 1, 1);
      mpq_QSchange_coef(lp, 2, 1, v1);
    }
#else
    {
      mpq_set_si(v1, 2, 10);
      mpq_QSnew_row(lp, v1, 'L', "c3");
      mpq_set_si(v1, 1, 20);
      mpq_QSchange_coef(lp, 2, 0, v1);
      mpq_set_si(v1, 1, 10);
      mpq_QSchange_coef(lp, 2, 1, v1);
    }
#endif
  }

#if 0
  mpq_QSwrite_prob(lp, "example.mps", "MPS");
#endif
  
  {
    int status, ret;
    ret = mpq_QSopt_primal(lp, &status);
    printf("primal ret=%d status=%d\n", ret, status);
    mpq_QSget_x_array (lp, x);
    gmp_printf("x=%Qd y=%Qd\n", x[0], x[1]);
    mpq_QSget_slack_array (lp, x);
    gmp_printf("slack c1=%Qd c2=%Qd c3=%Qd\n", x[0], x[1], x[2]);
    mpq_QSget_pi_array (lp, x);
    gmp_printf("pi c1=%Qd c2=%Qd c3=%Qd\n", x[0], x[1], x[2]);
  }
  
  mpq_QSfree_prob(lp);
  
  mpq_clear(x[0]);
  mpq_clear(x[1]);
  mpq_clear(x[2]);
  mpq_clear(v1);

  /* IMPORTANT NOTE
     All mpq_clear must occur BEFORE QSexactClear, which installs some custom allocator:
     EGlib
     g_lpnum.c:		mp_set_memory_functions(__EGgmp_malloc, __EGgmp_realloc, __EGgmp_free);
  */
  QSexactClear();
}
